<?php

namespace App\Http\Requests;


use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class CategoryRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('categories'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
       
$rules = [
    'image'=>'required'
    ];
         foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required',
               

            ];
            $rules= array_merge($rules, $lang_rules);
        }
       

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('categories');
        $attributes= [
            'image'=>  __('categories.image'),
            
        ];
         foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => $service->{'name_'.$lang->local} ?? __('categories.name'),
                'slug_'.$lang->local => $service->{'slug_'.$lang->local} ?? __('categories.slug'),
                'keywords_'.$lang->local => $service->{'keywords_'.$lang->local} ?? __('categories.keywords'),
                'meta_description_'.$lang->local => $service->{'meta_description_'.$lang->local} ?? __('categories.meta_description'),
                'description_'.$lang->local => $service->{'description_'.$lang->local} ?? __('categories.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
}
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
